image: $DEVOPS_GRADLE_IMAGE

variables:
  CI_API_V4_URL: https://git.company.com.br/api/v4

workflow:
  rules:
    # Não executamos automaticamente a esteira para branches >>DIFERENTES<< de GA e RC 
    - if: $CI_COMMIT_BRANCH !~ /^master|release$/ && $CI_PIPELINE_SOURCE =~ /^push|merge_request_event$/
      when: never
    - when: always

stages:
  - version
  - build_stage_1
  - build_stage_2
  - packaging
  - release

semantic_version:
  tags: 
    - QM 
  stage: version
  script:
    - >
      echo BUILD_NUMBER_PARENT=`date +%Y%m%d%H%M%S` >> build.env;
      echo CURRENT_DATE_ISO_PARENT=`date +%Y-%m-%dT%H:%M:%S%:z` >> build.env;
      
    # Definimos o channel baseado no nome da branch, master nao possui channel, é a padrão
    - >
      if [[ $CI_COMMIT_BRANCH == "master" ]]; then 
          RELEASE_CHANNEL="";
          ACRONYM_ORIGIN="ga";  
      elif [[ $CI_COMMIT_BRANCH == "release" ]]; then 
          RELEASE_CHANNEL="release";
          ACRONYM_ORIGIN="rc";
      elif [[ $CI_COMMIT_BRANCH == "develop" ]]; then 
          RELEASE_CHANNEL="develop";
          ACRONYM_ORIGIN="dev";
      else 
          RELEASE_CHANNEL="canary";
          
          if [[ $CI_COMMIT_BRANCH =~ '(feat|bugfix|hotfix)-(dev|ga|rc)-[a-z|A-Z|0-1|-]+' ]]; then
              ACRONYM_ORIGIN=BASH_REMATCH[2];
          else
              echo "Canary branch source not identified, branch name $CI_COMMIT_BRANCH don't contain channel dev,ga,rc";
              exit 31;   
          fi;
      fi;

    # Publicamos a variável de versão
    - >
      echo RELEASE_CHANNEL=$RELEASE_CHANNEL >> build.env;
      echo ACRONYM_ORIGIN=$ACRONYM_ORIGIN >> build.env;
    
    # Precisamos descobir com  a release
    - >
      if [[ $ACRONYM_ORIGIN == "ga" ]]; then 
          FILTER_BRANCH='/^v[0-9]+\.[0-9]+\.[0-9]+$/';
      elif [[ $ACRONYM_ORIGIN == "rc" ]]; then 
          FILTER_BRANCH='/^v[0-9]+\.[0-9]+\.[0-9]+-rc\.[0-9]+$/';
      else
          FILTER_BRANCH='/^v[0-9]+\.[0-9]+\.[0-9]+-dev\.[0-9]+$/';
      fi;

    # Buscamos a ultima tag existente na branch
    - >

      TAG_VERSION=$(echo $(git tag -l --sort=-v:refname | awk $FILTER_BRANCH | head -n 1 ));
      
      echo "TAG_VERSION=$TAG_VERSION";
      echo "TAG_VERSION=$TAG_VERSION" >> build.env;

      CURRENT_VERSION=$(echo $TAG_VERSION | sed -e 's/^v//g');
      
      echo "CURRENT_VERSION=$CURRENT_VERSION" >> build.env;
    
    # Descobrimos qual será a versão
    - >
      if [[ "$RELEASE_CHANNEL" = "canary" ]]; then
          (echo $CI_COMMIT_BRANCH > .VERSION);
      else 
          semantic-release --dry-run --no-ci;
         if [[ ! -e .VERSION ]]; then
              (echo $CURRENT_VERSION > .VERSION);
          fi;
      fi;

    # Publicamos a variável de versão
    - >
      NEXT_VERSION=$(cat .VERSION);
      echo "NEXT_VERSION=$NEXT_VERSION" >> build.env;
      echo "Picking tag version $NEXT_VERSION and channel $RELEASE_CHANNEL and project current version $CURRENT_VERSION";
  artifacts:
    reports:
      dotenv: build.env 

db_script: 
  stage: build_stage_1
  needs:
    - semantic_version
  variables:
    CI_ROOT_DIR: mgepes-dbscript
    NEXT_VERSION: $NEXT_VERSION
    RELEASE_CHANNEL: $RELEASE_CHANNEL
    CURRENT_DATE_ISO_PARENT: $CURRENT_DATE_ISO_PARENT
    BUILD_NUMBER_PARENT: $BUILD_NUMBER_PARENT
    PREVIOUS_VERSION: $CURRENT_VERSION
    PREVIOUS_TAG_VERSION: $TAG_VERSION
  trigger:
    include: module-a/.gitlab-ci.yml
    strategy: depend

db_dictionary: 
  stage: build_stage_2
  needs:
    - semantic_version
  variables:
    CI_ROOT_DIR: mgepes-datadictionary
    NEXT_VERSION: $NEXT_VERSION
    RELEASE_CHANNEL: $RELEASE_CHANNEL
    CURRENT_DATE_ISO_PARENT: $CURRENT_DATE_ISO_PARENT
    BUILD_NUMBER_PARENT: $BUILD_NUMBER_PARENT
  trigger:
    include: module-a/.gitlab-ci.yml
    strategy: depend    

packaging:
  stage: packaging
  needs:
    - semantic_version
    - db_dictionary
    - db_script
  variables:
    TARGET_VERSION: $NEXT_VERSION
    TARGET_CHANNEL: $RELEASE_CHANNEL
    TARGET_COMMIT_SHA: $CI_COMMIT_SHA
    TARGET_VERSION_ORIGIN: $CURRENT_VERSION
  trigger:
    project: 
    branch: master
    strategy: depend

release:
  stage: release
  tags:
    - QM
  needs:
    - packaging
  script:
    - semantic-release
  rules:
    - if: $CI_COMMIT_BRANCH =~ /^(master|release|develop)/